/* Sistemas Integrados TEKNISA
Nome: 0101_SDXSTPO_SDX_INSERE_NF_DEVOLUCAO.SQL

Descrio:
Rotina para gerao da RNF em tabelas.

Criao:
01/10/2009 - Cleison Rafael da Silva Ferreira
*/

CREATE OR REPLACE PROCEDURE SDX_INSERE_NF_DEVOLUCAO
AS

BEGIN
   FOR C_NFDEV IN (SELECT CDFILIAL||NRLANCTONF AS CDNOTAFISCORIG,
                          CDFILIAL,
                          NRLANCTONF,
                          CDEMPRESA,
                          NRINSJURNF,
                          NRNOTAFISC,
                          DTEMISSAO,
                          DTENTRSAID,
                          IDENTRSAIDOP,
                          CDTIPOOPER,
                          CDSERIE,
                          CDMODDOCFISC,
                          CDFILIEMIT,
                          CDFILIRECE,
                          CDALMOXARIFE,
                          CDLOCALESTOQ
                     FROM NOTAFISCAL
                    WHERE IDENTRSAIDOP = 'S'
                      AND CDTIPOOPER   = '06'
                      AND SDX_CDNOTAFISCORIG IS NULL
                    ORDER BY CDFILIAL, NRLANCTONF) LOOP

      INSERT INTO SDX_NOTAFISCAL
         (CDNOTAFISCORIG, CDFILIAL, CDEMPRESA, NRINSJURNF,
          NRNOTAFISC, DTEMISSAO, DTENTRSAID, IDENTRSAIDOP,
          CDTIPOOPER, CDSERIE, CDMODDOCFISC, CDFILIEMIT,
          CDFILIRECE, CDALMOXARIFE, CDLOCALESTOQ)
      VALUES
         (C_NFDEV.CDNOTAFISCORIG, C_NFDEV.CDFILIEMIT, C_NFDEV.CDEMPRESA, C_NFDEV.NRINSJURNF,
          C_NFDEV.NRNOTAFISC, C_NFDEV.DTEMISSAO, C_NFDEV.DTENTRSAID, C_NFDEV.IDENTRSAIDOP,
          C_NFDEV.CDTIPOOPER, C_NFDEV.CDSERIE, C_NFDEV.CDMODDOCFISC, C_NFDEV.CDFILIEMIT,
          C_NFDEV.CDFILIRECE, C_NFDEV.CDALMOXARIFE, C_NFDEV.CDLOCALESTOQ);

      FOR C_ITEMNF IN (SELECT I.CDFILIAL||I.NRLANCTONF AS CDNOTAFISCORIG,
                              I.CDFILIAL,
                              I.NRLANCTONF,
                              I.NRSEQITPROD,
                              P.CDARVPROD,
                              I.QTITEMPROD,
                              I.VRUNITITEM,
                              I.VRDESCITEM,
                              I.VRTOTAITEM,
                              I.CDFISOPEITEM,
                              I.CDSITUTRIBPR,
                              I.CDALMOXARIFE,
                              I.CDLOCALESTOQ,
                              I.NRLOTEESTQ,
                              I.NRSUBLOTE
                         FROM ITEMPRODUTO I, PRODUTO P
                        WHERE I.CDFILIAL   = C_NFDEV.CDFILIAL
                          AND I.NRLANCTONF = C_NFDEV.NRLANCTONF
                          AND I.CDPRODUTO  = P.CDPRODUTO
                        ORDER BY I.NRSEQITPROD) LOOP

         INSERT INTO SDX_ITEMPRODUTO
            (CDNOTAFISCORIG, CDFILIAL, CDPRODUTO, QTITEMPROD,
             VRUNITITEM, VRDESCITEM, VRTOTAITEM, CDFISOPEITEM,
             CDSITUTRIBPR, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
             NRSUBLOTE)
         VALUES
            (C_ITEMNF.CDNOTAFISCORIG, C_NFDEV.CDFILIEMIT, C_ITEMNF.CDARVPROD, C_ITEMNF.QTITEMPROD,
             C_ITEMNF.VRUNITITEM, C_ITEMNF.VRDESCITEM, C_ITEMNF.VRTOTAITEM, C_ITEMNF.CDFISOPEITEM,
             C_ITEMNF.CDSITUTRIBPR, C_ITEMNF.CDALMOXARIFE, C_ITEMNF.CDLOCALESTOQ, C_ITEMNF.NRLOTEESTQ,
             C_ITEMNF.NRSUBLOTE);
      END LOOP;
         INSERT INTO SDX_CONTROLEINT
            (CDNOTAFISCORIG, DTEXPORTACAO, DTIMPORTACAO, DSOBSERVERROS)
         VALUES
            (C_NFDEV.CDNOTAFISCORIG, SYSDATE, NULL, '');

         UPDATE NOTAFISCAL
            SET SDX_CDNOTAFISCORIG = C_NFDEV.CDNOTAFISCORIG
          WHERE NRLANCTONF = C_NFDEV.NRLANCTONF
            AND CDFILIAL   = C_NFDEV.CDFILIAL;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SDX_INSERE_NF_DEVOLUCAO','5.09.000'); END;
/